
CON

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000


var
byte buf[2520]
byte line_buf[672] ' 4 lines 2 line buffers
long color_buf[60] ' color buffer for lines


byte border_red
byte border_green
byte border_blue

byte back_red
byte back_green
byte back_blue

byte font_red
byte font_green
byte font_blue

long buf_ptr
long font_ptr
long bord_color
long font_color 'font and background
long line_buf_ptr
long color_buf_ptr

pub demo | random, i


font_red:=2
font_green:=3
font_blue:=3
back_red:=0
back_green:=1
back_blue:=2
border_red:=0
border_green:=0
border_blue:=1


repeat i from 0 to 2519
  buf[i]:=i

repeat i from 0 to 29
  code_colors(i)



start

random:=cnt

repeat
  waitcnt (cnt+80000000)

  repeat i from 0 to 29

    font_red:=random? & 3
    font_green:=random? & 3
    font_blue:=random? & 3
    back_red:=random? & 3
    back_green:=random? & 3
    back_blue:=random? & 3
    border_red:=random? & 3
    border_green:=random? & 3
    border_blue:=random? & 3

    code_colors(i)


pub code_colors(line) | tc

bord_color:=border_red<<6+border_green<<4+border_blue<<2+3
bord_color:=bord_color<<24+bord_color<<16+bord_color<<8+bord_color

tc:=font_red<<6+font_green<<4+font_blue<<2+3
font_color:=back_red<<6+back_green<<4+back_blue<<2+3
font_color+=tc<<8
font_color+=font_color<<16
color_buf[2*line]:=bord_color
color_buf[2*line+1]:=font_color


pub start

buf_ptr:=@buf
line_buf_ptr:=@line_buf
font_ptr:=@st_font
color_buf_ptr:=@color_buf

cognew(@vga_start,@buf_ptr)
cognew(@cache_start,@buf_ptr)



dat
st_font                 file "st3font.def"


dat
vga_start               org               0

init_vga                mov buffer_addr,par
                        add buffer_addr,#8
                        mov b_col_ptr,buffer_addr       'border color
                        add buffer_addr,#4
                        mov std_col_ptr,buffer_addr     'font and background colors
                        add buffer_addr,#4
                        mov l_b_ptra,buffer_addr        '8 lines line buffer pointer
                        add buffer_addr,#4
                        rdlong c_b_ptra, buffer_addr    'color buffer

                        mov dira,pinmask
                        mov outa,#$00
                        mov ctra,#0
                        movi ctra,#%0_00001_101         'pll div 4
                        mov frqa,frqa_val               '32 MHz pixel clock

                        mov vscl,vscl_val
                        mov vcfg,vcfg_val
                        rdlong l_b_ptr,l_b_ptra

                        'start of frame rendering

frame              '     rdlong border_color,b_col_ptr    'border color can be changed in real time

                        mov l_count,#10                  '10 lines of back porch
bp_loop                 call #blank_line
                        djnz l_count,bp_loop

'                        rdlong std_colors,std_col_ptr    'font and back colors can be changed

                        mov l_count,#60                  '60 lines of upper border
up_frm_loop             call #frame_line
                        djnz l_count,up_frm_loop

                        mov linenum, #0
                        mov l_count,#480                 '480 lines picture
line_loop               call #normal_line
                        djnz l_count,line_loop

                        mov l_count,#60                  '40 lines of lower frame
d_frm_loop              call #frame_line
                        djnz l_count,d_frm_loop

                        mov l_count,#15                  '15 lines of front porch
fp_loop                 call #blank_line
                        djnz l_count,fp_loop

                        mov l_count,#15                  '15 lines of vsync
vbl_loop                call #vsync_line
                        djnz l_count,vbl_loop

                        jmp  #frame

                        ' End of frame; start of subroutines

blank_line              mov p_count,#29
bl1                     waitvid blank_color,blank_pixels
                        djnz p_count,#bl1
                        mov p_count,#3
bl2                     waitvid hblk_color,blank_pixels
                        djnz p_count,#bl2
blank_line_ret          ret

vsync_line              mov p_count,#29
vl1                     waitvid vblank_color,blank_pixels
                        djnz p_count,#vl1
                        mov p_count,#3
vl2                     waitvid vhblk_color,blank_pixels
                        djnz p_count,#vl2
vsync_line_ret          ret

frame_line              mov p_count,#2                       'back porch
fl1                     waitvid blank_color,blank_pixels
                        djnz p_count,#fl1
                        mov p_count,#25                      '768 pixels of border
fl2                     waitvid border_color,blank_pixels
                        djnz p_count,#fl2
                        mov p_count,#2                       'front porch
fl3                     waitvid blank_color,blank_pixels
                        djnz p_count,#fl3
                        mov p_count,#3                        'hsync
fl4                     waitvid hblk_color,blank_pixels
                        djnz p_count,#fl4
frame_line_ret          ret


normal_line             mov linenum, #480
                        sub linenum,l_count
                        shr linenum, #4
                        shl linenum, #3


                        mov p_count,#2                       'back porch
nl1                     waitvid blank_color,blank_pixels
                        djnz p_count,#nl1


                        add linenum,c_b_ptra
                        rdlong border_color,linenum
                        add linenum,#4
                        rdlong std_colors,linenum


                        mov p_count,#2                       '64 pixels of border
nl2                     waitvid border_color,blank_pixels
                        djnz p_count,#nl2

                        mov p_count,#21                      '672 pixels of picture
nl3                     rdlong temp_buff,l_b_ptr             '4 bytes to cog memory
                        waitvid std_colors,temp_buff
                        add l_b_ptr,#4
                        djnz p_count,#nl3
                        add t_cnt, #1                        'line buffer line counter

                        mov p_count,#2                       '64 pixels of border
nl4                     waitvid border_color,blank_pixels
                        djnz p_count,#nl4




                        mov p_count,#2                       'front porch
nl5                     waitvid blank_color,blank_pixels
                        djnz p_count,#nl5

                        cmp t_cnt, #8           wz
                if_z    sub l_b_ptr,a672

                        mov p_count,#3                        'hsync
nl6                     waitvid hblk_color,blank_pixels
                        djnz p_count,#nl6

                        and t_cnt,#$07
normal_line_ret         ret



l_count                 long    0
p_count                 long    0
frqa_val                long    $1A000000       '32 Mhz pixel clock
vscl_val                long    $00001020       '1 clock/pixel, 32 clock/frame
vcfg_val                long    $200004ff       'video vga, 2 colors, 16..23


blank_color             long    $03030303       'high sync
hblk_color              long    $01010101       'hblk, hsync low
vhblk_color             long    0               'all sync low
vblank_color            long    $02020202       'vsync low
border_color            long    0
std_colors              long    0

blank_pixels            long    0
pinmask                 long    $00FF0000
buffer_addr             long    0
temp_buff               long    $00000000
b_col_ptr               long    0
std_col_ptr             long    0
font_b_ptr              long    0
t_cnt                   long    0
l_b_ptr                 long    0
a672                    long    672
hsyncmask               long    %00000000_00000010_00000000_00000000
vsyncmask               long    %00000000_00000001_00000000_00000000
l_b_ptra                long 0
c_b_ptra                long 0
linenum                 long 0
linenum2                long 0
                        fit 496


dat
cache_start             org     0


                        mov buffer_addr2,par
                        rdlong m_b_ptr2,buffer_addr2
                        add buffer_addr2,#4
                        rdlong f_b_ptr2,buffer_addr2
                        add buffer_addr2,#12
                        rdlong l_b_ptr2,buffer_addr2

                        'wait for vsync

vsync                   waitpeq zero,vsyncmask2
                        waitpeq vsyncmask2,vsyncmask2

                        mov counter2,#66

                        'waiting for 66 lines (porch plus border-4)

loop1                   waitpeq zero,hsyncmask2
                        waitpeq hsyncmask2,hsyncmask2
                        djnz counter2,#loop1
                        mov counter4,#30

loop10
                        'create 4 lines of display data

                        mov counter3,#84        '4
loop2                   rdbyte char,m_b_ptr2    '8

                        cmp char,#128            wc '4
              if_nc     mov xormask,ffffffff        '4
              if_c      mov xormask,zero            '4
                        and char,#127           '4
                        shl char,#4             '4
                        add char,f_b_ptr2       '4
                        rdlong bytes, char      '8
                        xor bytes,xormask       '4
                        add m_b_ptr2,#1         '4
                        wrbyte bytes,l_b_ptr2   '8
                        add l_b_ptr2,#84        '4
                        shr bytes,#8            '4
                        wrbyte bytes,l_b_ptr2   '8
                        add l_b_ptr2,#84        '4
                        shr bytes,#8            '4
                        wrbyte bytes,l_b_ptr2   '8
                        add l_b_ptr2,#84        '4
                        shr bytes,#8            '4
                        wrbyte bytes,l_b_ptr2   '8
                        sub l_b_ptr2,#251       '4
                        djnz counter3,#loop2    '4             '112 cycles, 1.4 us/loop, 117.6 us/all

                        waitpeq zero,hsyncmask2
                        waitpeq hsyncmask2,hsyncmask2


'Second half of buffer with the same letters code

                        add l_b_ptr2,#252
                        sub m_b_ptr2,#84
                        add f_b_ptr2,#4


                        mov counter3,#84       '4
loop4                   rdbyte char,m_b_ptr2    '8
                        cmp char,#128            wc
              if_nc     mov xormask,ffffffff
              if_c      mov xormask,zero
                        and char,#127
                        shl char,#4
                        add char,f_b_ptr2
                        rdlong bytes, char
                        xor bytes,xormask
                        add m_b_ptr2,#1
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        sub l_b_ptr2,#251
                        djnz counter3,#loop4

                        waitpeq zero,hsyncmask2
                        waitpeq hsyncmask2,hsyncmask2


'third quarter of chars; switch to first half of buffer

                        sub l_b_ptr2,#420
                        sub m_b_ptr2,#84
                        add f_b_ptr2,#4


                        mov counter3,#84
loop6                   rdbyte char,m_b_ptr2
                        cmp char,#128            wc
              if_nc     mov xormask,ffffffff
              if_c      mov xormask,zero
                        and char,#127
                        shl char,#4
                        add char,f_b_ptr2
                        rdlong bytes, char
                        xor bytes,xormask
                        add m_b_ptr2,#1
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        sub l_b_ptr2,#251
                        djnz counter3,#loop6

                        waitpeq zero,hsyncmask2
                        waitpeq hsyncmask2,hsyncmask2

'last quarter of char

                        add l_b_ptr2, #252
                        sub m_b_ptr2,#84
                        add f_b_ptr2,#4



                        mov counter3,#84
loop8                   rdbyte char,m_b_ptr2
                        cmp char,#128            wc
              if_nc     mov xormask,ffffffff
              if_c      mov xormask,zero
                        and char,#127
                        shl char,#4
                        add char,f_b_ptr2
                        rdlong bytes, char
                        xor bytes,xormask
                        add m_b_ptr2,#1
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#84
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        sub l_b_ptr2,#251
                        djnz counter3,#loop8

                        waitpeq zero,hsyncmask2
                        waitpeq hsyncmask2,hsyncmask2

' line is finished

                        sub f_b_ptr2,#12
                        sub l_b_ptr2,#420

                        djnz counter4,#loop10
                        rdlong m_b_ptr2,par

                        jmp     #vsync

zero                    long    0
ffffffff                long    $FFFFFFFF

l_b_ptr2                long    0
f_b_ptr2                long    0
m_b_ptr2                long    0

char                    long    0
bytes                   long    0

xormask                 long    0
counter2                long    0
counter3                long    0
counter4                long    0

buffer_addr2            long    0
hsyncmask2              long    %00000000_00000010_00000000_00000000
vsyncmask2              long    %00000000_00000001_00000000_00000000

